<script setup lang="ts">
import { reactive, ref, onMounted, toRaw, defineAsyncComponent } from 'vue';
import { PageContainer } from 'antdv-pro-layout';
import { Modal, TableColumnsType, message } from 'ant-design-vue/es';
import { SizeType } from 'ant-design-vue/es/config-provider';
import { MenuInfo } from 'ant-design-vue/es/menu/src/interface';
import useNeInfoStore from '@/store/modules/neinfo';
import useI18n from '@/hooks/useI18n';
import useDictStore from '@/store/modules/dict';
import { NE_TYPE_LIST } from '@/constants/ne-constants';
import { RESULT_CODE_SUCCESS } from '@/constants/result-constants';
import { listNeLicense, stateNeLicense } from '@/api/ne/neLicense';
import { parseDateToStr } from '@/utils/date-utils';
const { t } = useI18n();
const { getDict } = useDictStore();
const EditModal = defineAsyncComponent(
  () => import('./components/EditModal.vue')
);

/**字典数据-状态 */
let dictStatus = ref<DictType[]>([]);

/**网元参数 */
let neOtions = ref<Record<string, any>[]>([]);

/**查询参数 */
let queryParams = reactive({
  /**网元类型 */
  neType: undefined,
  /**网元ID */
  neId: '',
  /**序列号 */
  serialNum: '',
  /**当前页数 */
  pageNum: 1,
  /**每页条数 */
  pageSize: 20,
});

/**查询参数重置 */
function fnQueryReset() {
  queryParams = Object.assign(queryParams, {
    neType: undefined,
    neId: '',
    serialNum: '',
    pageNum: 1,
    pageSize: 20,
  });
  tablePagination.current = 1;
  tablePagination.pageSize = 20;
  fnGetList();
}

/**表格状态类型 */
type TabeStateType = {
  /**加载等待 */
  loading: boolean;
  /**紧凑型 */
  size: SizeType;
  /**搜索栏 */
  seached: boolean;
  /**记录数据 */
  data: any[];
  /**勾选记录 */
  selectedRowKeys: (string | number)[];
};

/**表格状态 */
let tableState: TabeStateType = reactive({
  loading: false,
  size: 'middle',
  seached: false,
  data: [],
  selectedRowKeys: [],
});

/**表格字段列 */
let tableColumns = ref<TableColumnsType>([
  {
    title: t('common.rowId'),
    dataIndex: 'id',
    align: 'left',
    width: 100,
  },
  {
    title: t('views.ne.common.neType'),
    dataIndex: 'neType',
    align: 'left',
    width: 100,
  },
  {
    title: t('views.ne.common.neId'),
    dataIndex: 'neId',
    align: 'left',
    width: 100,
  },
  {
    title: t('views.ne.neLicense.status'),
    dataIndex: 'status',
    key: 'status',
    align: 'left',
    width: 120,
  },
  {
    title: t('views.ne.common.serialNum'),
    dataIndex: 'serialNum',
    align: 'left',
    width: 100,
  },
  {
    title: t('views.ne.common.expiryDate'),
    dataIndex: 'expiryDate',
    align: 'left',
    width: 120,
  },
  {
    title: t('common.remark'),
    dataIndex: 'remark',
    key: 'remark',
    align: 'left',
    width: 150,
    resizable: true,
    minWidth: 100,
    maxWidth: 300,
  },
  {
    title: t('common.updateTime'),
    dataIndex: 'updateTime',
    align: 'center',
    customRender(opt) {
      if (!opt.value) return '';
      return parseDateToStr(opt.value);
    },
    width: 150,
  },
  {
    title: t('common.operate'),
    key: 'id',
    align: 'left',
  },
]);

/**表格分页器参数 */
let tablePagination = reactive({
  /**当前页数 */
  current: 1,
  /**每页条数 */
  pageSize: 20,
  /**默认的每页条数 */
  defaultPageSize: 20,
  /**指定每页可以显示多少条 */
  pageSizeOptions: ['10', '20', '50', '100'],
  /**只有一页时是否隐藏分页器 */
  hideOnSinglePage: false,
  /**是否可以快速跳转至某页 */
  showQuickJumper: true,
  /**是否可以改变 pageSize */
  showSizeChanger: true,
  /**数据总数 */
  total: 0,
  showTotal: (total: number) => t('common.tablePaginationTotal', { total }),
  onChange: (page: number, pageSize: number) => {
    tablePagination.current = page;
    tablePagination.pageSize = pageSize;
    queryParams.pageNum = page;
    queryParams.pageSize = pageSize;
    fnGetList();
  },
});

/**表格紧凑型变更操作 */
function fnTableSize({ key }: MenuInfo) {
  tableState.size = key as SizeType;
}

/**表格多选 */
function fnTableSelectedRowKeys(keys: (string | number)[]) {
  tableState.selectedRowKeys = keys;
}

/**查询列表, pageNum初始页数 */
function fnGetList(pageNum?: number) {
  if (tableState.loading) return;
  tableState.loading = true;
  if (pageNum) {
    queryParams.pageNum = pageNum;
  }
  listNeLicense(toRaw(queryParams)).then(res => {
    if (res.code === RESULT_CODE_SUCCESS && Array.isArray(res.rows)) {
      tablePagination.total = res.total;
      tableState.data = res.rows.filter(s => s.neType !== 'OMC');
      if (
        tablePagination.total <=
          (queryParams.pageNum - 1) * tablePagination.pageSize &&
        queryParams.pageNum !== 1
      ) {
        tableState.loading = false;
        fnGetList(queryParams.pageNum - 1);
      }
    } else {
      tablePagination.total = 0;
      tableState.data = [];
    }
    tableState.loading = false;
  });
}

/**对话框对象信息状态类型 */
type ModalStateType = {
  /**新增框或修改框是否显示 */
  openByEdit: boolean;
  /**授权记录ID */
  licenseId: string;
  /**确定按钮 loading */
  confirmLoading: boolean;
};

/**对话框对象信息状态 */
let modalState: ModalStateType = reactive({
  openByEdit: false,
  licenseId: '',
  confirmLoading: false,
});

/**
 * 对话框弹出显示为 新增或者修改
 * @param licenseId id
 */
function fnModalVisibleByEdit(licenseId: string) {
  modalState.licenseId = licenseId;
  modalState.openByEdit = true;
}

/**
 * 对话框弹出确认执行函数
 * 进行表达规则校验
 */
function fnModalOk() {
  // 获取列表数据
  fnGetList();
}

/**
 * 对话框弹出关闭执行函数
 * 进行表达规则校验
 */
function fnModalCancel() {
  modalState.openByEdit = false;
  modalState.licenseId = '';
}

/**刷新网元授权状态 */
function fnRecordState(row: Record<string, any>) {
  if (modalState.confirmLoading) return;
  Modal.confirm({
    title: t('common.tipTitle'),
    content: t('views.ne.neLicense.reloadTip'),
    onOk() {
      modalState.confirmLoading = true;
      const hide = message.loading(t('common.loading'), 0);
      stateNeLicense(row.neType, row.neId)
        .then(res => {
          if (res.code === RESULT_CODE_SUCCESS) {
            row.status = '1';
            row.serialNum = res.data.sn;
            row.expiryDate = res.data.expire;
            message.success(
              `${row.neType} ${row.neId} ${dictStatus.value[1].label}`,
              3
            );
          } else {
            row.status = '0';
            message.warning(
              `${row.neType} ${row.neId} ${dictStatus.value[0].label}`,
              3
            );
          }
        })
        .finally(() => {
          modalState.confirmLoading = false;
          hide();
        });
    },
  });
}

/**刷新网元授权状态 勾选 */
function fnRecordStateBatch() {
  if (modalState.confirmLoading) return;
  Modal.confirm({
    title: t('common.tipTitle'),
    content: t('views.ne.neLicense.reloadBatchTip'),
    onOk: async () => {
      modalState.confirmLoading = true;
      const hide = message.loading(t('common.loading'), 0);
      // 勾选的网元数据
      const selectRows = tableState.data.filter(item =>
        tableState.selectedRowKeys.includes(item.id)
      );

      for (const row of selectRows) {
        if (row.neType.toUpperCase() === 'OMC') {
          continue;
        }
        const res = await stateNeLicense(row.neType, row.neId);
        if (res.code === RESULT_CODE_SUCCESS && res.data) {
          row.status = '1';
          row.serialNum = res.data.sn;
          row.expiryDate = res.data.expire;
        } else {
          row.status = '0';
        }
        tableState.selectedRowKeys = [];
      }
      message.success(t('common.operateOk'), 3);
      hide();
      modalState.confirmLoading = false;
    },
  });
}

onMounted(() => {
  // 初始字典数据
  getDict('ne_license_status').then(res => {
    dictStatus.value = res;
  });
  // 获取网元网元列表
  useNeInfoStore()
    .fnNelist()
    .then(res => {
      if (res.code === RESULT_CODE_SUCCESS && Array.isArray(res.data)) {
        neOtions.value = useNeInfoStore().getNeSelectOtions;
      } else {
        message.warning({
          content: t('common.noData'),
          duration: 2,
        });
      }
    })
    .finally(() => {
      // 获取列表数据
      fnGetList();
    });
});
</script>

<template>
  <PageContainer>
    <a-card
      v-show="tableState.seached"
      :bordered="false"
      :body-style="{ marginBottom: '24px', paddingBottom: 0 }"
    >
      <!-- 表格搜索栏 -->
      <a-form :model="queryParams" name="queryParams" layout="horizontal">
        <a-row :gutter="16">
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item :label="t('views.ne.common.neType')" name="neType ">
              <a-auto-complete
                v-model:value="queryParams.neType"
                :options="NE_TYPE_LIST.map(v => ({ value: v }))"
                :allow-clear="true"
                :placeholder="t('common.inputPlease')"
              />
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item :label="t('views.ne.common.neId')" name="neId">
              <a-input
                v-model:value="queryParams.neId"
                :allow-clear="true"
                :placeholder="t('common.inputPlease')"
              ></a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item
              :label="t('views.ne.common.serialNum')"
              name="serialNum"
            >
              <a-input
                v-model:value="queryParams.serialNum"
                :allow-clear="true"
                :placeholder="t('common.inputPlease')"
              ></a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item>
              <a-space :size="8">
                <a-button type="primary" @click.prevent="fnGetList(1)">
                  <template #icon><SearchOutlined /></template>
                  {{ t('common.search') }}
                </a-button>
                <a-button type="default" @click.prevent="fnQueryReset">
                  <template #icon><ClearOutlined /></template>
                  {{ t('common.reset') }}
                </a-button>
              </a-space>
            </a-form-item>
          </a-col>
        </a-row>
      </a-form>
    </a-card>

    <a-card :bordered="false" :body-style="{ padding: '0px' }">
      <!-- 插槽-卡片左侧侧 -->
      <template #title>
        <a-space :size="8" align="center">
          <a-button
            type="default"
            :disabled="tableState.selectedRowKeys.length <= 0"
            :loading="modalState.confirmLoading"
            @click.prevent="fnRecordStateBatch()"
          >
            <template #icon><CloudSyncOutlined /></template>
            {{ t('views.ne.neLicense.reloadBatch') }}
          </a-button>
        </a-space>
      </template>

      <!-- 插槽-卡片右侧 -->
      <template #extra>
        <a-space :size="8" align="center">
          <a-tooltip>
            <template #title>{{ t('common.searchBarText') }}</template>
            <a-switch
              v-model:checked="tableState.seached"
              :checked-children="t('common.switch.show')"
              :un-checked-children="t('common.switch.hide')"
              size="small"
            />
          </a-tooltip>
          <a-tooltip>
            <template #title>{{ t('common.reloadText') }}</template>
            <a-button type="text" @click.prevent="fnGetList()">
              <template #icon><ReloadOutlined /></template>
            </a-button>
          </a-tooltip>
          <a-tooltip placement="topRight">
            <template #title>{{ t('common.sizeText') }}</template>
            <a-dropdown placement="bottomRight" trigger="click">
              <a-button type="text">
                <template #icon><ColumnHeightOutlined /></template>
              </a-button>
              <template #overlay>
                <a-menu
                  :selected-keys="[tableState.size as string]"
                  @click="fnTableSize"
                >
                  <a-menu-item key="default">
                    {{ t('common.size.default') }}
                  </a-menu-item>
                  <a-menu-item key="middle">
                    {{ t('common.size.middle') }}
                  </a-menu-item>
                  <a-menu-item key="small">
                    {{ t('common.size.small') }}
                  </a-menu-item>
                </a-menu>
              </template>
            </a-dropdown>
          </a-tooltip>
        </a-space>
      </template>

      <!-- 表格列表 -->
      <a-table
        class="table"
        row-key="id"
        :columns="tableColumns"
        :loading="tableState.loading"
        :data-source="tableState.data"
        :size="tableState.size"
        :pagination="tablePagination"
        :scroll="{ x: tableColumns.length * 120 }"
        @resizeColumn="(w:number, col:any) => (col.width = w)"
        :row-selection="{
          type: 'checkbox',
          columnWidth: '48px',
          selectedRowKeys: tableState.selectedRowKeys,
          onChange: fnTableSelectedRowKeys,
        }"
      >
        <template #bodyCell="{ column, record }">
          <template v-if="column.key === 'status'">
            <DictTag :options="dictStatus" :value="record.status" />
          </template>
          <template v-if="column.key === 'remark'">
            <a-tooltip placement="topLeft">
              <template #title>{{ record.remark }}</template>
              <div
                style="
                  overflow: hidden;
                  text-overflow: ellipsis;
                  white-space: nowrap;
                  cursor: pointer;
                  width: 50px;
                "
                :style="{ width: column.width + 'px' }"
              >
                {{ record.remark }}
              </div>
            </a-tooltip>
          </template>
          <template v-if="column.key === 'id'">
            <a-space :size="8" align="center">
              <a-tooltip placement="topRight">
                <template #title>{{ t('views.ne.neLicense.reload') }}</template>
                <a-button type="link" @click.prevent="fnRecordState(record)">
                  <template #icon><CloudSyncOutlined /> </template>
                </a-button>
              </a-tooltip>
              <a-tooltip placement="topRight">
                <template #title>{{ t('views.ne.neLicense.change') }}</template>
                <a-button
                  type="link"
                  @click.prevent="fnModalVisibleByEdit(record.id)"
                >
                  <template #icon><CloudUploadOutlined /> </template>
                </a-button>
              </a-tooltip>
            </a-space>
          </template>
        </template>
      </a-table>
    </a-card>

    <!-- 文件上传框 -->
    <EditModal
      v-model:open="modalState.openByEdit"
      :edit-id="modalState.licenseId"
      @ok="fnModalOk"
      @cancel="fnModalCancel"
    ></EditModal>
  </PageContainer>
</template>

<style lang="less" scoped>
.table :deep(.ant-pagination) {
  padding: 0 24px;
}
</style>
